Nested Grid - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

Nested Grids

Smart.Grid can display nested grids by using the Row Detail functionality. When enabled, by expanding a Grid row, a Nested Grid is displayed showing additional details about the respective data. That is achieved by setting rowDetail.enabled to true and implementing the onRowDetailInit callback function.

Additional settings available in the rowDetail object are:

  • height - sets the height of the row details.
  • position - sets the position of the Column which allows you to dynamically expand/collapse the row details - 'near' (left) or 'far' (right).
  • template - sets the template of the row details.
  • visible - sets the visibility of the column which allows you to dynamically expand/collapse the row details.
  • dialog - sets the row details dialog. Described in detail in the section Nested Grids in Dialog in this article.

More information: property rowDetail in the Grid API documentation.

The onRowDetailInit callback function is called when a row detail is initializing and allows for a initial per-row modification of the row detail template. The nested grid is configured and initialized in this function. The onRowDetailUpdated callback function is called when a row detail is udpating and allows for a additional modifications of the row detail.


More information: property onRowDetailInit in the Grid API documentation.
More information: property onrowdetailupdated in the Grid API documentation.
onRowDetailInit(index, row, detail) {
    const grid = document.createElement('div');

    detail.appendChild(grid);

    const gridInstance = new Smart.Grid(grid, {
        dataSource: new Smart.DataAdapter({
            dataSource: getCountriesData().filter(data => data.ID === row.data.ID),
            dataFields: [
                'ID: number',
                'Country: string',
                'Area: number',
                'Population_Urban: number',
                'Population_Rural: number',
                'Population_Total: number',
                'GDP_Agriculture: number',
                'GDP_Industry: number',
                'GDP_Services: number',
                'GDP_Total: number'
            ]
        }),
        columns: [
            'Population_Urban',
            'Population_Rural',
            'Population_Total',
            'GDP_Total'
        ]
    });
},
rowDetail: {
    enabled: true,
    visible: true,
    height: 120
}

Nested Grids can be shown by pressing the toggle arrow in the row details column or by setting showDetail to true in a row's respective object. The height and template of a particular row's detail can be modified by setting detailHeight and detailTemplate respectively.

Row details can display any information and are not limited to just nested Grids.

Nested Grids in Dialog

If rowDetail.dialog.enabled is set to true, nested Grids are displayed in a separate pop-up dialog. Additional settings part of the rowDetail.dialog object that allow configuring this dialog are:

  • header - sets the header of the dialog.
  • height - sets the height of the dialog.
  • width - sets the width of the dialog.
  • left - sets the left position of the dialog.
  • top - sets the top position of the dialog.

Row Detail-related Methods:

For AI tooling

Developer Quick Reference

Topic: grid-nested-grids   Component: Grid   Framework: JavaScript

Main methods: (none detected)

Common config keys: dataSource, columns

Implementation Notes

Compatibility: Modern browsers / Web Components   API access pattern: const component = document.querySelector(...) + component.method()

Lifecycle guidance: Initialize configuration first, then invoke imperative API when element is available in DOM.

Common pitfalls:

  • Calling methods before element initialization.
  • Reassigning large configuration partially without understanding merge behavior.
  • Missing required module script import for component type.

Validation checklist:

  • Ensure module scripts and CSS are loaded once.
  • Keep data schema aligned with columns/series definitions.
  • Verify method calls target initialized component instance.

Nested Grid - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

Grid for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { Grid } from 'smart-webcomponents-react/grid';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Grid ref={componentRef} {...componentProps}></Grid>;
}

Use componentRef.current for API methods in this topic.

Nested Grids

Smart.Grid can display nested grids by using the Row Detail functionality. When enabled, by expanding a Grid row, a Nested Grid is displayed showing additional details about the respective data. That is achieved by setting rowDetail.enabled to true and implementing the onRowDetailInit callback function.

Additional settings available in the rowDetail object are:

  • height - sets the height of the row details.
  • position - sets the position of the Column which allows you to dynamically expand/collapse the row details - 'near' (left) or 'far' (right).
  • template - sets the template of the row details.
  • visible - sets the visibility of the column which allows you to dynamically expand/collapse the row details.
  • dialog - sets the row details dialog. Described in detail in the section Nested Grids in Dialog in this article.

More information: property rowDetail in the Grid API documentation.

The onRowDetailInit callback function is called when a row detail is initializing and allows for a initial per-row modification of the row detail template. The nested grid is configured and initialized in this function. The onRowDetailUpdated callback function is called when a row detail is udpating and allows for a additional modifications of the row detail.


More information: property onRowDetailInit in the Grid API documentation.
More information: property onrowdetailupdated in the Grid API documentation.
onRowDetailInit(index, row, detail) {
    const grid = document.createElement('div');

    detail.appendChild(grid);

    const gridInstance = new Smart.Grid(grid, {
        dataSource: new Smart.DataAdapter({
            dataSource: getCountriesData().filter(data => data.ID === row.data.ID),
            dataFields: [
                'ID: number',
                'Country: string',
                'Area: number',
                'Population_Urban: number',
                'Population_Rural: number',
                'Population_Total: number',
                'GDP_Agriculture: number',
                'GDP_Industry: number',
                'GDP_Services: number',
                'GDP_Total: number'
            ]
        }),
        columns: [
            'Population_Urban',
            'Population_Rural',
            'Population_Total',
            'GDP_Total'
        ]
    });
},
rowDetail: {
    enabled: true,
    visible: true,
    height: 120
}

Nested Grids can be shown by pressing the toggle arrow in the row details column or by setting showDetail to true in a row's respective object. The height and template of a particular row's detail can be modified by setting detailHeight and detailTemplate respectively.

Row details can display any information and are not limited to just nested Grids.

Nested Grids in Dialog

If rowDetail.dialog.enabled is set to true, nested Grids are displayed in a separate pop-up dialog. Additional settings part of the rowDetail.dialog object that allow configuring this dialog are:

  • header - sets the header of the dialog.
  • height - sets the height of the dialog.
  • width - sets the width of the dialog.
  • left - sets the left position of the dialog.
  • top - sets the top position of the dialog.

Row Detail-related Methods:

For AI tooling

Developer Quick Reference

Topic: grid-nested-grids   Component: Grid   Framework: React

Main methods: (none detected)

Common config keys: dataSource, columns

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

Nested Grid - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

Grid for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { GridComponent, GridModule } from 'smart-webcomponents-angular/grid';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GridModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('grid', { read: GridComponent, static: false }) grid!: GridComponent;
}
<!-- app.component.html -->
<smart-grid #grid></smart-grid>

Use this.grid for API methods in this topic.

Nested Grids

Smart.Grid can display nested grids by using the Row Detail functionality. When enabled, by expanding a Grid row, a Nested Grid is displayed showing additional details about the respective data. That is achieved by setting rowDetail.enabled to true and implementing the onRowDetailInit callback function.

Additional settings available in the rowDetail object are:

  • height - sets the height of the row details.
  • position - sets the position of the Column which allows you to dynamically expand/collapse the row details - 'near' (left) or 'far' (right).
  • template - sets the template of the row details.
  • visible - sets the visibility of the column which allows you to dynamically expand/collapse the row details.
  • dialog - sets the row details dialog. Described in detail in the section Nested Grids in Dialog in this article.

More information: property rowDetail in the Grid API documentation.

The onRowDetailInit callback function is called when a row detail is initializing and allows for a initial per-row modification of the row detail template. The nested grid is configured and initialized in this function. The onRowDetailUpdated callback function is called when a row detail is udpating and allows for a additional modifications of the row detail.


More information: property onRowDetailInit in the Grid API documentation.
More information: property onrowdetailupdated in the Grid API documentation.
onRowDetailInit(index, row, detail) {
    const grid = document.createElement('div');

    detail.appendChild(grid);

    const gridInstance = new Smart.Grid(grid, {
        dataSource: new Smart.DataAdapter({
            dataSource: getCountriesData().filter(data => data.ID === row.data.ID),
            dataFields: [
                'ID: number',
                'Country: string',
                'Area: number',
                'Population_Urban: number',
                'Population_Rural: number',
                'Population_Total: number',
                'GDP_Agriculture: number',
                'GDP_Industry: number',
                'GDP_Services: number',
                'GDP_Total: number'
            ]
        }),
        columns: [
            'Population_Urban',
            'Population_Rural',
            'Population_Total',
            'GDP_Total'
        ]
    });
},
rowDetail: {
    enabled: true,
    visible: true,
    height: 120
}

Nested Grids can be shown by pressing the toggle arrow in the row details column or by setting showDetail to true in a row's respective object. The height and template of a particular row's detail can be modified by setting detailHeight and detailTemplate respectively.

Row details can display any information and are not limited to just nested Grids.

Nested Grids in Dialog

If rowDetail.dialog.enabled is set to true, nested Grids are displayed in a separate pop-up dialog. Additional settings part of the rowDetail.dialog object that allow configuring this dialog are:

  • header - sets the header of the dialog.
  • height - sets the height of the dialog.
  • width - sets the width of the dialog.
  • left - sets the left position of the dialog.
  • top - sets the top position of the dialog.

Row Detail-related Methods:

For AI tooling

Developer Quick Reference

Topic: grid-nested-grids   Component: Grid   Framework: Angular

Main methods: (none detected)

Common config keys: dataSource, columns

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.

Nested Grid - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

Grid for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.grid.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-grid ref="component"></smart-grid>
</template>

Use component.value for API methods in this topic.

Nested Grids

Smart.Grid can display nested grids by using the Row Detail functionality. When enabled, by expanding a Grid row, a Nested Grid is displayed showing additional details about the respective data. That is achieved by setting rowDetail.enabled to true and implementing the onRowDetailInit callback function.

Additional settings available in the rowDetail object are:

  • height - sets the height of the row details.
  • position - sets the position of the Column which allows you to dynamically expand/collapse the row details - 'near' (left) or 'far' (right).
  • template - sets the template of the row details.
  • visible - sets the visibility of the column which allows you to dynamically expand/collapse the row details.
  • dialog - sets the row details dialog. Described in detail in the section Nested Grids in Dialog in this article.

More information: property rowDetail in the Grid API documentation.

The onRowDetailInit callback function is called when a row detail is initializing and allows for a initial per-row modification of the row detail template. The nested grid is configured and initialized in this function. The onRowDetailUpdated callback function is called when a row detail is udpating and allows for a additional modifications of the row detail.


More information: property onRowDetailInit in the Grid API documentation.
More information: property onrowdetailupdated in the Grid API documentation.
onRowDetailInit(index, row, detail) {
    const grid = document.createElement('div');

    detail.appendChild(grid);

    const gridInstance = new Smart.Grid(grid, {
        dataSource: new Smart.DataAdapter({
            dataSource: getCountriesData().filter(data => data.ID === row.data.ID),
            dataFields: [
                'ID: number',
                'Country: string',
                'Area: number',
                'Population_Urban: number',
                'Population_Rural: number',
                'Population_Total: number',
                'GDP_Agriculture: number',
                'GDP_Industry: number',
                'GDP_Services: number',
                'GDP_Total: number'
            ]
        }),
        columns: [
            'Population_Urban',
            'Population_Rural',
            'Population_Total',
            'GDP_Total'
        ]
    });
},
rowDetail: {
    enabled: true,
    visible: true,
    height: 120
}

Nested Grids can be shown by pressing the toggle arrow in the row details column or by setting showDetail to true in a row's respective object. The height and template of a particular row's detail can be modified by setting detailHeight and detailTemplate respectively.

Row details can display any information and are not limited to just nested Grids.

Nested Grids in Dialog

If rowDetail.dialog.enabled is set to true, nested Grids are displayed in a separate pop-up dialog. Additional settings part of the rowDetail.dialog object that allow configuring this dialog are:

  • header - sets the header of the dialog.
  • height - sets the height of the dialog.
  • width - sets the width of the dialog.
  • left - sets the left position of the dialog.
  • top - sets the top position of the dialog.

Row Detail-related Methods:

For AI tooling

Developer Quick Reference

Topic: grid-nested-grids   Component: Grid   Framework: Vue

Main methods: (none detected)

Common config keys: dataSource, columns

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with